#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf pmac-utils-2.1.tar.gz
    cd pmac-utils-2.1
    make nvsetenv CFLAGS="$CFLAGS -fsigned-char"
    strip -R .note -R .comment nvsetenv
    mkdir -p ../nvsetenv/sbin
    cp nvsetenv ../nvsetenv/sbin/
    cd ..
    rm -rf pmac-utils-2.1
}

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
[ "$ARCH" != 'powerpc' ] && exit 0

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done

